import { Group, Summary } from "./types";
/**
 * @param name - name of the summary
 * @param data - data to be processed
 * @param group - define whether the summary is for a sample or a population
 * @param rounded - (optional) decimal place to round off the values
 */
export default class Descriptive {
    name: string;
    data: Array<number>;
    group: Group;
    size: number;
    summary: Summary;
    private rounded;
    constructor(name: string, data: Array<number>, group: Group, rounded?: number | false);
    private sum;
    private mean;
    private median;
    private mode;
    private max;
    private min;
    private variance;
    private standardDeviation;
    private sumOfSquareDeviations;
}
